<?php

//---------------------------------------------------------------------------------------------------------------------
// RUN AND PARSE NBNOTE
//---------------------------------------------------------------------------------------------------------------------
$netblog_sc_cites = array();

$netblog_sc_cite_attsDft = array(
		'author' => '',
		'title' => '',
		'year' => '',
		'city' => '',
		'publisher' => '',
		'publisher_place' => '',
		'pages' => '',	
		'volume' => '',
		'bookauthor' => '',
		'booktitle' => '',
		'title_periodical' => '',
		'month' => '',
		'day' => '',
		'yearacc' => '',
		'monthacc' => '',
		'dayacc' => '',
		'url' => '',
		'doi' => '',
		'conference_name' => '',
		'yearorg' => '',
		'pagesorg' => '',
		'composer' => '',
		'conductor' => '',
		'performer' => '',
		'writer' => '',
		'theater' => '',
		'director' => '',
		'movie' => '',
		'inventor' => '',
		'patentnum' => '',
		'casenum' => '',
		'court' => '',
		'source' => '',
		'special' => '',
		'webpage' => '',			//=title
		'website' => '',			//=publisher
		'type' => '',
		'print' => '',
		'print_sections' => 'false',
		'print_headline' => '',
		'print_custom' => ''
      );
      
$netblog_cite_types = array(
		'book' => 'Books',
		'booksection' => 'Book Sections',
		'journal'=>'Journal Articles',
		'magazine' => 'Magazine Articles',
		'newspaper' => 'Newspaper Articles',
		'encyclopedia' => 'Encyclopedia Articles',
		'conference' => 'Conference Proceedings',
		'report' => 'Report',
		'eric' => 'ERIC Document',
		'website' => 'Websites',
		'wiki' => 'Wiki',
		'blog' => 'Blog',
		'video' => 'Internet Video',
		'powerpoint' => 'PowerPoint Presentation',
		'art' => 'Art',
		'recording' => 'Sound Recording',
		'performance' => 'Performance',
		'film' => 'Film',
		'patent' => 'Patent',
		'case' => 'Case'
);
		
function netblog_sc_cite( $atts, $content = null )
{
	global $netblog_sc_cites;
	global $netblog_sc_cite_attsDft, $netblog_cite_types;
	$a = shortcode_atts( $netblog_sc_cite_attsDft, $atts );

    $scope = constant('NETBLOG_CITE_TAG');
    $a['type'] = strtolower($a['type']);   

	if( $a['print'] == '' ) {		
		extract($a);
		$out = '';
		
		if( $author == '' && $title == '' )
			return '<font style="color:red">Invalid Citation: missing author and/or title</font>';
		
		if( $author!='' ) {
			$t = explode(',', $author);
			if( sizeof($t) > 5 || (sizeof($t) > 2 && netblog_sc_cite_exists($a)) )
				$author = $t[0].' et al.';
			$out = "$author";
		} else if( $title!='' ) $out = "\"$title\""; 
		
		if( $year!='' ) $out .= ", $year";
		else $out .= ", n.d.";
		
		if( $pages!='' ) $out .= ", $pages";
		
		$out = "($out)";
		
		// CUSTOM OUTPUT
		$outC = '';		
		if( $print_custom!='' && $outC=eval("return \"$print_custom\" ;") )
			$out = $outC;
		
		netblog_sc_cite_add($a);
		return "<i>$out</i>";
		
		
	} else {
		$out = '';			
		$o = Array();
		$heads = $netblog_cite_types;
		if( $a['print_headline'] != '' && ($content == null || strlen($content) == 0) )
			$content = $a['print_headline'];
		if( $content == null || strlen($content) == 0 )
			$content = 'References';
		
		//var_dump($a['print']);
		if( strlen($a['print']) == 0 || $a['print'] == 'default' || get_option('netblog_cite_style_override') == 'true' )
			$a['print'] = get_option('netblog_cite_style');
			
		switch( strtoupper($a['print']) ) {
			
			// APA STYLE
			case 'APA':
				foreach( $netblog_sc_cites as $type=>$list )
				foreach( $list as $src ) {
					extract($src);
					switch($type){
						case 'journal': $o[$type][] = "$author ($year). $title <i>$title_periodical, $volume</i>, $pages. $doi"; break;
						case 'magazine': $o[$type][] = "$author ($year, $month). $title <i>$title_periodical, $volume</i>, $pages."; break;
						case 'newspaper': 
							if($url!='') $o[$type][] = "$author ($year, $month $day). $title <i>$title_periodical</i>, $pages.";
							else $o[$type][] = "$author ($year, $month $day). $title <i>$title_periodical</i>. Retrieved from $url.";
							break;
						case 'book': 
							if($author!='') $o[$type][] = "$author ($year). <i>$title</i> $publisher_place: $publisher."; 
							else $o[$type][] = "<i>$title</i> ($year). $publisher_place: $publisher.";
							break;
						case 'booksection': $o[$type][] = "$author ($year). $title In $bookauthor, <i>$booktitle</i> ($pages). $publisher_place: $publisher."; break;
						case 'encyclopedia': $o[$type][] = "$author ($year). $title In $bookauthor, <i>$booktitle</i> ($volume, $pages). $publisher_place: $publisher."; break;
						case 'eric': $o[$type][] = "$author ($year). <i>$title</i> Retrieved from ERIC databse. ($doi)"; break;
						case 'website': case 'web':
							if($author=='') $o[$type][] = "<i>$title</i> ($year, $month $day). Retrieved $monthacc $dayacc, $yearacc, from $publisher website: $url";
							else if( $author != $publisher ) $o[$type][] = "$author ($year, $month $day). <i>$title</i> Retrieved from $publisher website: $url";
							else if( $author == $publisher ) $o[$type][] = "$author ($year, $month $day). <i>$title</i> Retrieved from $url";
							else  $o[$type][] = "$author ($year, $month $day). <i>$title</i> Retrieved $monthacc $dayacc, $yearacc, from $publisher website: $url";
							break;
						case 'wiki': $o[$type][] = "$title (n.d.). In <i>Wikipedia</i>. Retrieved $monthacc $dayacc, $yearacc, from $url"; break;
						case 'blog': $o[$type][] = "$author ($year, $month $day). $title [Weblog message]. Retrieved from $url"; break;
						case 'video': $o[$type][] = "$author ($year, $month $day). $title [Video file]. Retrieved from $url"; break;
						case 'powerpoint': case 'ppt':  $o[$type][] = "$author ($year). <i>$title</i> [PowerPoint slides]. Retrieved from $publisher website:$url"; break;
					}
				}
				break;
				
			// TURABIAN STYLE
			case 'TURABIAN':
				foreach( $netblog_sc_cites as $type=>$list )
				foreach( $list as $src ) {
					extract($src);
					switch($type){
						case 'book': 
							if($author!='') $o[$type][] = "$author. $year. <i>$title</i> $publisher_place: $publisher."; 
							else $o[$type][] = "<i>$title</i> $year. $publisher_place: $publisher.";
							break;
						case 'journal': 
							if($author!='') $o[$type][] = "$author. $year. $title <i>$title_periodical</i> $volume ($month): $pages";
							else $o[$type][] = "$title $year. <i>$title_periodical</i> $volume ($month): $pages"; break;
						case 'magazine': case 'newspaper':
							if($author!='') $o[$type][] = "$author. $year. $title <i>$title_periodical</i> $day $month, $pages";
							else $o[$type][] = "$title $year. <i>$title_periodical</i> $day $month, $pages"; break;							 
						case 'encyclopedia':
							if($author!='') $o[$type][] = "$author, \"$title\", in <i>$publisher</i>, $year";
							else $o[$type][] = "\"$title\", in <i>$publisher</i>, $year"; break;		
						case 'booksection':
							if($author!='') $o[$type][] = "$author. $year. $title In <i>$booktitle</i>, $bookauthor, $pages. $publisher_place: $publisher.";
							else $o[$type][] = "$title $year. In <i>$booktitle</i>, $bookauthor, $pages. $publisher_place: $publisher."; break;
						case 'eric':
							if($author!='') $o[$type][] = "$author. $year. <i>$title</i> $publisher_place: $publisher. ERIC, $doi.";
							else $o[$type][] = "<i>$title</i> $year. $publisher_place: $publisher. ERIC, $doi."; break;
						case 'website': case 'web':
							if($author!='') $o[$type][] = "$author. $year. <i>$title</i> $publisher_place: $publisher. On-line. Available from Internet, $url, accessed $dayacc $monthacc $yearacc.";
							else $o[$type][] = "<i>$title</i> $year. $publisher_place: $publisher. On-line. Available from Internet, $url, accessed $dayacc $monthacc $yearacc."; break;
					}
				}
				break;

				
			// MLA STYLE
			case 'MLA':
				foreach( $netblog_sc_cites as $type=>$list )
				foreach( $list as $src ) {
					extract($src);
					if( trim($author) != '' ) $author .= '.';
					if( trim($special) != '' ) $special .= '.';  
					switch($type){
						case 'journal':
							if( $source == 'web' ) $o[$type][] = "$author \"$title\" <i>$title_periodical</i> $volume ($year): $pages. $publisher. Web. $dayacc $monthacc $yearacc.";
							else if( $source == 'db' ) $o[$type][] = "$author \"$title\" <i>$title_periodical</i> $volume ($year): $pages. Web. $dayacc $monthacc $yearacc.";
							else $o[$type][] = "$author \"$title\" <i>$title_periodical</i> $volume ($year): $pages. Print.";							
							break;
						case 'newspaper':
							if( $source == 'web' ) $o[$type][] = "$author \"$title\" <i>$title_periodical</i>. $publisher, $day $month $year. Web. $dayacc $monthacc $yearacc.";
							else if( $source == 'movie' ) $o[$type][] = "$author \"$title\" Rev. of $movie, dir. $director. <i>$title_periodical</i> $day $month $year, sec. $pages. Print.";
							else $o[$type][] = "$author \"$title\" <i>$title_periodical</i>. $publisher, $day $month $year: $pages. Print.";
							break;
						case 'magazine':
							if( $source == 'web' ) $o[$type][] = "$author \"$title\" $special <i>$title_periodical</i> $month $year: $pages. $publisher. Web. $dayacc $monthacc $yearacc.";
							else if( $source == 'db' ) $o[$type][] = "$author \"$title\" $special <i>$title_periodical</i> $month $year: $pages. Web. $dayacc $monthacc $yearacc.";							
							else $o[$type][] = "$author \"$title\" $special <i>$title_periodical</i> $month $year: $pages. Print.";
							break;
						case 'book':
							if( $source == 'web' || $source == 'db' ) 
								$o[$type][] = "$author <i>$title</i> $publisher_place: $publisher, $year. Web. $dayacc $monthacc $yearacc.";														
							else $o[$type][] = "$author <i>$title</i> $publisher_place: $publisher, $year. Print.";
							break;
						case 'booksection':
							$o[$type][] = "$author \"$title\" <i>$booktitle</i>. $bookauthor. $publisher_place: $publisher, $year. $pages. Print.";
							break;
						case 'encyclopedia':
							if( $source == 'web' || $source == 'db' ) 
								$o[$type][] = "$author \"$title\" <i>$booktitle</i>. $bookauthor. $volume. $publisher_place: $publisher, $year. Web. $dayacc $monthacc $yearacc.";														
							else $o[$type][] = "$author \"$title\" <i>$booktitle</i>. $special $year. Print.";
							break;
						case 'gale':
							$o[$type][] = "$author \"$title\" <i>$title_periodical</i> $day $month $year: $pages. Rpt in <i>$booktitle</i>. Ed. $bookauthor. $volume. $publisher_place: $publisher, $yearorg. $pagesorg. Literature Criticism Online. Web. $dayacc $monthacc $yearacc.";
							break;
						case 'website': case 'web':
							$o[$type][] = "$author \"$title\" <i>$title_periodical</i> $publisher, $day $month $year. Web. $dayacc $monthacc $yearacc.";
							break;
						case 'blog':						
							$o[$type][] = "$author \"$title\" $special <i>$title_periodical</i> $publisher, $day $month $year. Web. $dayacc $monthacc $yearacc.";
							break;
						case 'wiki':						
							$o[$type][] = "\"$title\". <i>Wikipedia: The Free Encyclopedia.</i> Wikimedia Foundation, n.d. Web. From $url. $dayacc $monthacc $yearacc.";
							break;
						case 'video':
							$o[$type][] = "$author dir. \"$title\". <i>$title_periodical</i>. $publisher, $day $month $year. Web. $url $dayacc $monthacc $yearacc.";break;
						case 'powerpoint': case 'ppt':
							$o[$type][] = "$author \"$title\" $publisher, $day $month $year. <i>Microsoft PowerPoint</i> file. $url $dayacc $monthacc $yearacc.";break;
						case 'eric':
							$o[$type][] = "$author $title. $publisher_place: $publisher, $year. <i>ERIC</i>. Web. $url $dayacc $monthacc $yearacc.";break;
					}
				}
				break;				
				
				
				
			// CHICAGO STYLE
			case 'CHICAGO':
				foreach( $netblog_sc_cites as $type=>$list )
				foreach( $list as $src ) {
					extract($src);				
					switch($type){
						case 'book': 
							if($author!='') $o[$type][] = "$author. $year. <i>$title</i> $publisher_place: $publisher."; 
							else $o[$type][] = "<i>$title</i> $year. $publisher_place: $publisher.";
							break;
						case 'journal': 
							if($author!='') $o[$type][] = "$author. $year. $title <i>$title_periodical</i> $volume ($month): $pages";
							else $o[$type][] = "$title $year. <i>$title_periodical</i> $volume ($month): $pages"; break;
						case 'magazine': case 'newspaper':
							if($author!='') $o[$type][] = "$author. $year. $title <i>$title_periodical</i> $month $day.";
							else if($type=='newspaper') $o[$type][] = "<i>$title_periodical</i> $year. $title $month $day, $special."; 
							else $o[$type][] = "$title $year. <i>$title_periodical</i> $month $day."; break;							 
//						case 'encyclopedia':
//							if($author!='') $o[$type][] = "$author, \"$title\", in <i>$publisher</i>, $year";
//							else $o[$type][] = "\"$title\", in <i>$publisher</i>, $year"; break;		
						case 'booksection':
							if($author!='') $o[$type][] = "$author. $year. $title In <i>$booktitle</i>, $bookauthor, $pages. $publisher_place: $publisher.";
							else $o[$type][] = "$title $year. In <i>$booktitle</i>, $bookauthor, $pages. $publisher_place: $publisher."; break;
						case 'eric':
							if($author!='') $o[$type][] = "$author. $year. <i>$title</i> $publisher_place: $publisher, text-fiche, $doi.";
							else $o[$type][] = "<i>$title</i> $year. $publisher_place: $publisher. ERIC, $doi."; break;
						case 'website': case 'web':
							if($author!='') $o[$type][] = "$author. $year. <i>$title</i> $publisher. $url (accessed $monthacc $dayacc, $yearacc).";
							else $o[$type][] = "<i>$title</i> $year. $publisher. $url (accessed $monthacc $dayacc, $yearacc)."; break;
					}
				}
				break;
				
			// AMA STYLE
			case 'AMA':
				foreach( $netblog_sc_cites as $type=>$list )
				foreach( $list as $src ) {
					extract($src);
					if( trim($author) != '' ) $author .= '.';
					if( trim($special) != '' ) $special .= '.';  
					switch($type){	
							
					}
				}
				

			default:
				foreach( $netblog_sc_cites as $type=>$list )
				foreach( $list as $src ) {
					extract($src);
					$style = $a['print'];
					$print_custom = '';
					if( ($print_custom=netblog_sc_cite_getFilter($style,$type)) != false ) {
						$o[$type][] = eval("return \"$print_custom\" ;");
					}
				}				
							
		}
			
		// PRINT LIST
		if( $print_sections == 'true' ) {
			$out = "<h1>$content</h1>";
			foreach( $o as $t=>$c )
				$out .= netblog_sc_cite_print( $c, $heads[$t], 'h2' );
		} else {
			$t = array();
			foreach( $o as $c )
				$t = array_merge($t,$c);
			$out = netblog_sc_cite_print( $t, $content, 'h1', '', '<div style="height:50px"></div>' );
		}

		return $out;
	}   
}

function netblog_sc_cite_add( $att )
{
	global $netblog_sc_cites;
	$id = netblog_sc_cite_mkid($att);
	if( !isset($netblog_sc_cites[ $att['type'] ][$id]) ) {
		$netblog_sc_cites[ $att['type'] ][$id] = $att;
		return $id;
	} else return false;
}
function netblog_sc_cite_exists( $att )
{
	global $netblog_sc_cites;
	$id = netblog_sc_cite_mkid($att);
	return isset($netblog_sc_cites[ $att['type'] ][$id]);
}

function netblog_sc_cite_print( $formattedOutput, $title, $titleTag, $before = '', $after = '' ) 
{
	$o = "$before<$titleTag>$title</$titleTag>";
	foreach( $formattedOutput as $k=>$v) 
		$formattedOutput[$k] = trim($v);
	sort( $formattedOutput );
	foreach( $formattedOutput as $c ) 
		$o .= '<div style="text-indent: -25px; padding-left: 25px; line-height: 200%">'.$c.'</div>';
	return $o.$after;
}

function netblog_sc_cite_mkid( $att )
{
	return $att['author'].$att['title'].$att['year'].$att['month'].$att['day'].$att['pages'];
}


function netblog_sc_cite_styles_default()
{
	return array('apa'=>'APA','turabian'=>'Turabian','mla'=>'MLA','chicago'=>'Chicago');
}
function netblog_sc_cite_get_attsdft()
{
	global $netblog_sc_cite_attsDft;
	return $netblog_sc_cite_attsDft;
}


function netblog_sc_cite_mkfilterName( $style, $type ) 
{
	return "nbcite-$style-$type";
}
function netblog_sc_cite_addFilter( $style, $type, $exec )
{
	$default = netblog_sc_cite_styles_default();
	$exec = netblog_cite_parse_cstring($exec);
	if( isset( $default[ strtolower($style) ] ) ) return false;
	
	if( strlen($style) > 20 || strlen($type) > 20 ) return false;
	if( strlen($style) < 3 || strlen($type) < 3 ) return false;
	if( strlen($exec) < 3 ) return false;
	
	$nm = netblog_sc_cite_mkfilterName($style,$type);
	if( get_option($nm) === false ) {
		add_option($nm,$exec,'','no');
		return true;
	} else update_option($nm,$exec);
}
function netblog_sc_cite_rmFilter( $style, $type )
{
	$nm = netblog_sc_cite_mkfilterName($style,$type);
	if( get_option($nm) != false ) {
		delete_option($nm);
		return true;
	} else return false;
}
function netblog_sc_cite_getFilter( $style, $type )
{
	return get_option( netblog_sc_cite_mkfilterName($style,$type) );
}

function netblog_sc_cite_custom_filter()
{
	global $wpdb;
	$out = array();
	$query = "
		SELECT o.option_name, o.option_value FROM $wpdb->options o
		WHERE o.option_name LIKE 'nbcite-%'
		ORDER BY o.option_name
	";
	$r = $wpdb->get_results($query,ARRAY_A);	
	foreach( $r as $option )
		$out[ $option['option_name'] ] = $option['option_value'];
	return $out;
}
function netblog_sc_cite_styles_custom() 
{
	$s = array();
	$r = netblog_sc_cite_custom_filter();
	foreach( $r as $k=>$v ) {
		$s[netblog_sc_cite_getStyleFromFilter($k)] = netblog_sc_cite_getStyleFromFilter($k);
	}
	return implode(', ',$s);
}
function netblog_sc_cite_getStyleFromFilter( $filter )
{
	$t = explode('-',$filter);
	return $t[1];
}
function netblog_sc_cite_getTypeFromFilter( $filter )
{
	$t = explode('-',$filter);
	return $t[2];
}
function netblog_sc_cite_filter_types_default()
{
	global $netblog_cite_types;
	return $netblog_cite_types;
}
function netblog_cite_parse_cstring( $cstring )
{
	$cstring = str_replace("$",'',$cstring);
	//$cstring = str_replace("'",'"',$cstring);
	$dft = netblog_sc_cite_get_attsdft();
	foreach( $dft as $k=>$v ) {
		$t = explode($k,$cstring);
		if( sizeof($t) > 1 ) {
//			echo $k.' ';
//			var_dump($t);
			for( $i=1; $i<sizeof($t); $i++ )
				if( strlen($t[$i]) > 0 && ctype_alnum(substr($t[$i],0,1)) ) {
					$t[$i-1] .= $k.$t[$i];
					unset($t[$i--]);
				}
//			var_dump($t);
//			echo '<br /><br />';
			$cstring = implode("$$k",$t);
		}				
	}
	return $cstring;
}


//---------------------------------------------------------------------------------------------------------------------
// REGISTER FOOTNOTE - NBCITE
//---------------------------------------------------------------------------------------------------------------------
add_shortcode( constant('NETBLOG_CITE_TAG'), 'netblog_sc_cite');

?>