<?php
/*
 * REQUIRES DEFINITION OF
 * 	- NETBLOG FUNCTIONS OF COMMON DB-QUERIES
 */


//----------------------------------------------------------------------------------
// SERVER-SIDE AJAX-HANDLER
//----------------------------------------------------------------------------------
add_action('wp_ajax_send_autocomplete', 'netblog_ajax_send_autocomplete');
function netblog_ajax_send_autocomplete() {
	global $wpdb;
	global $post;
	$net = $wpdb->prefix . constant('NETBLOG_DB_NET');
	
	$str = addslashes($_POST['query']);
	$nodeID = $_POST['nodeID'];
	$out = array();
	$exturi = false;
	$exturiBeg = explode(' ', get_option('netblog_websearch_keywords') );
	$num = 0;
	
	for( $i=0; $i<sizeof($exturiBeg); $i++ )
		if( substr($str, 0, strlen($exturiBeg[$i]) ) ==  $exturiBeg[$i] ) {
			$exturi = true; break;
		}
	
	// INTERN NET
	if( !$exturi ) {
		$queryNoChld = "
			SELECT post_type, post_title, p.ID, post_content, user_nicename, post_date, post_status
		    FROM $wpdb->posts p, $wpdb->users u
	     	WHERE p.post_title like '$str%'
	      	AND p.ID != $nodeID
		    AND (p.post_type = 'post' || p.post_type = 'page')
	      	AND p.post_author = u.ID
		    ORDER BY p.post_date DESC
		    LIMIT 10;
		";																							//UPDT_1.2 - page
		$queryChld = "
			SELECT post_type, post_title, p.ID, post_content, user_nicename, post_date, post_status
			FROM $wpdb->posts p, $net n, $wpdb->users u
			WHERE n.id = '$nodeID'
			AND !(p.ID = n.adj_id)
			AND p.ID != '$nodeID'
			AND (p.post_type = 'post' || p.post_type = 'page')
			AND p.post_title LIKE '$str%'
			AND p.post_author = u.ID
			LIMIT 10;
		";																							//UPDT_1.2 - page
		
		$query = '';
		if( netblog_hasAdjacent($nodeID) )
			$query = $queryChld;
		else $query = $queryNoChld;
				    
		$adjsIntern = $wpdb->get_results($query, ARRAY_A);
		for( $i=0; $i<sizeof($adjsIntern); $i++ ) {
			//$adjs[$num]['type'] = 'intern';
			//array_merge( $adjs[$num], $adjsIntern[$i] );
			$out[$num] = $adjsIntern[$i];
			$out[$num]['post_content'] = substr( strip_tags($adjsIntern[$i]['post_content']), 0, 200).'...';
			$num++;
		}
		
	// EXTERN NET
	} else if( constant('NETBLOG_WEBSEARCH_MAX') != 0 ) {
		$uri = str_replace( '??query??', $str, constant('NETBLOG_WEBSEARCH_URI') );
		$uri = str_replace( '??count??', constant('NETBLOG_WEBSEARCH_MAX'), $uri );
		$rss = fetch_feed( $uri );
				//var_dump($rss);				
		if( !is_wp_error($rss) ) {
			$max = constant('NETBLOG_WEBSEARCH_MAX');
			$maxItems = $rss->get_item_quantity( constant('NETBLOG_WEBSEARCH_MAX')>0 ? constant('NETBLOG_WEBSEARCH_MAX') : 0 );	// 0 := all items
			$rss_items = $rss->get_items(0, $maxItems);
					
			if( $maxItems != 0 )
			foreach( $rss_items as $k=>$item ) 
				if( !netblog_isAdjacent($nodeID, $item->get_permalink(),true) ) {
					$out[$num]['type'] = 'extern';
					$out[$num]['title'] = $item->get_title();
					$out[$num]['uri'] = $item->get_permalink();
					$num++;
				}
		}
	}
	echo netblog_ajax_parse_nodeInfos($out);
	die();  
}

add_action('wp_ajax_send_autocompleteGroups', 'netblog_ajax_send_autocompleteGroups');
function netblog_ajax_send_autocompleteGroups() {
	global $wpdb;
	global $post;
	$net = $wpdb->prefix . constant('NETBLOG_DB_NET');
	
	$str = addslashes($_POST['query']);
	$nodeID = $_POST['nodeID'];
	$out = array();
	$num = 0;
	
	
	//
	// INTERN NET - LOCAL POSTS AND PAGES
	//
	$queryNoChld = "
		SELECT post_type, post_title, p.ID, post_content, user_nicename, post_date, post_status
	    FROM $wpdb->posts p, $wpdb->users u
     	WHERE p.post_title like '%$str%'
      	AND p.ID != $nodeID
	    AND (p.post_type = 'post' || p.post_type = 'page')
	    AND p.post_status = 'publish'
      	AND p.post_author = u.ID
	    ORDER BY p.post_date DESC
	    LIMIT 10;
	";																							//UPDT_1.2 - page
//	$queryChld = "
//		SELECT post_type, post_title, p.ID, post_content, user_nicename, post_date, post_status
//		FROM $wpdb->posts p, $net n, $wpdb->users u
//		WHERE n.id = '$nodeID'
//		AND !(p.ID = n.adj_id)
//		AND p.ID != '$nodeID'
//		AND (p.post_type = 'post' || p.post_type = 'page')
//		AND p.post_title LIKE '%$str%'
//		AND p.post_author = u.ID
//		LIMIT 10;
//	";																							//UPDT_1.2 - page
	$queryChld = "
		SELECT post_type, post_title, p.ID, post_content, user_nicename, post_date, post_status
		FROM $wpdb->posts p, $wpdb->users u
		WHERE (p.post_type = 'post' || p.post_type = 'page')
		AND p.post_status = 'publish'
		AND p.post_title LIKE '%$str%'
		AND p.ID != '$nodeID'
		AND p.post_author = u.ID;
	";
	
	$query = '';
	if( netblog_hasAdjacent($nodeID) )
		$query = $queryChld;
	else $query = $queryNoChld;

	//file_put_contents(dirname(__FILE__).'\query.txt',$query);
	
	$adjsIntern = $wpdb->get_results($query, ARRAY_A);
	$numI = 0;
	for( $i=0; $i<sizeof($adjsIntern) && $numI < 10; $i++ ) {
		// PREVENT DOUPLICATES
		if( netblog_isAdjacent($nodeID,$adjsIntern[$i]['ID']) ) continue;
		
		// ADD
		$out[$num] = $adjsIntern[$i];
		$out[$num]['post_content'] = substr( strip_tags($adjsIntern[$i]['post_content']), 0, 200).'...';
		$num++; $numI++;
	}
	
	//
	// MEDIA - LOCAL ATTACHMENTS
	//
	$query = "	SELECT post_mime_type, post_title, p.ID, post_content, user_nicename, post_date, post_status
				FROM $wpdb->posts p, $wpdb->users u
				WHERE p.post_type = 'attachment'
				AND p.post_title LIKE '%$str%'
				AND p.post_mime_type LIKE '%pdf%'
				AND p.post_author = u.ID;
	";
	$media = $wpdb->get_results($query, ARRAY_A);
	$numI = 0;
	for( $i=0; $i<sizeof($media) && $numI < 10; $i++ ) {
		// PREVENT DOUPLICATES
		if( netblog_isAdjacent($nodeID,$media[$i]['ID']) ) continue;

		// ADD
		$out[$num] = $media[$i];
		//$out[$num]['post_type'] = 'media';
		$num++; $numI++;
	}
	
		
	//
	// EXTERN NET
	//
	if( constant('NETBLOG_WEBSEARCH_MAX') > 0 ) {
		$uri = str_replace( '??query??', $str, constant('NETBLOG_WEBSEARCH_URI') );
		$uri = str_replace( '??count??', constant('NETBLOG_WEBSEARCH_MAX'), $uri );
		$rss = fetch_feed( $uri );			
		if( !is_wp_error($rss) ) {
			$max = constant('NETBLOG_WEBSEARCH_MAX');
			$maxItems = $rss->get_item_quantity( constant('NETBLOG_WEBSEARCH_MAX')>0 ? constant('NETBLOG_WEBSEARCH_MAX') : 0 );	// 0 := all items
			$rss_items = $rss->get_items(0, $maxItems);
					
			if( $maxItems != 0 )
			foreach( $rss_items as $k=>$item ) 
				if( !netblog_isAdjacent($nodeID, $item->get_permalink(),true) ) {
					$out[$num]['type'] = 'extern';
					$out[$num]['title'] = $item->get_title();
					$out[$num]['uri'] = $item->get_permalink();
					$num++;
				}
		}
	}
	echo netblog_ajax_parse_nodeInfos($out);
	die();	
}


add_action('wp_ajax_get_links', 'netblog_ajax_get_links');
function netblog_ajax_get_links()
{
	global $wpdb;
	$q = trim($_POST['query']);	
	$o = array();
	if( $q == '' ) $q = 'tpl:new';
	
	// PARSE ARGS
	$limit = 0; $sortBy = 'uri_id'; $flag = null; $refs = 0; $tpl = null;
	$pars = explode(' ',$q);
	$paramFrg = array();
	foreach( $pars as $k=>$p ) {
		$num = 0; $p = strtolower($p);
		if( substr($p,0,6) == 'limit:' && is_numeric( $num=substr($p,6) ) && $num > 0 ) $limit = $num;
		else if( substr($p,0,5) == 'sort:' && strlen($p) > 5 ) $sortBy = substr($p,5);
		else if( substr($p,0,5) == 'flag:' && strlen($p) > 5 ) $flag = substr($p,5);
		else if( substr($p,0,4) == 'tpl:' && strlen($p) > 4 ) $tpl = substr($p,4);
		else $paramFrg[] = $pars[$k];
	}
	
	$template = false;
	
	// JUST ADDED
	if( $tpl == 'new' ) {
		$template = true;
		$sortBy = "uri_id desc,$sortBy";
	}
	
	// MOST POPULAR
	if( $tpl == 'popular' ) {
		$template = true;
		$sortBy = "refs desc,$sortBy";
	}

	// OFFLINE, TRASHED
	if( $tpl == 'offline' || $tpl == 'trash' || $tpl == 'lock' ) {
		$template = true;
		$flag = $tpl;
	}

	$r = Array();
	if( sizeof($paramFrg) == 0 )
		$r = netblog_get_uris( explode(',',$sortBy), $limit, $flag, $refs);
	else $r = netblog_get_uris_match( $paramFrg[0], explode(',',$sortBy), $limit, $flag);
	
	if( is_array($r) )
	foreach( $r as $c )
		$o[] = array( $c['uri_id'], $c['uri'], $c['uri_title'], 
				'By ' . netblog_cstrip(netblog_getNodesByAdjacentAsString($c['uri'],true,5 ),200,'...'), 
				$c['flag'], $c['refs'] );
	echo netblog_ajax_parse_nodeInfos($o);		
	die();
}


add_action('wp_ajax_send_link', 'netblog_ajax_send_link');
function netblog_ajax_send_link()
{
	$flag = $_POST['flag'];
	$uri = $_POST['uri'];
	$title = $_POST['title'];
	$o = array();
	
	switch($flag){
		// SIMPLE FLAG-UPDATE
		// 0 	:= normal
		// 1 	:= offline
		// 2	:= trash
		// 3	:= erase
		// 4 	:= restore
		// 99	:= locked
		// 100	:= > unlock
		case 0: case 1: case 2: case 99: 
			if( netblog_updateURIbyID($_POST['uri_id'],$_POST['uri'],$_POST['title'],$flag) ) {
				$o[] = array( $_POST['uri_id'],$_POST['uri'],$_POST['title'],$flag );
				echo netblog_ajax_parse_nodeInfos($o); 
			} else echo 'false';
			break;
			
		// PERMANENT REMOVAL
		case 3:
			if( netblog_removeURI($uri) )
				echo 'true';
			else 
				echo 'false';
			break;	
			
		// UNLOCK
		case 100:
			$node = netblog_getURI($uri);
			if( $node['flag'] == '99' )
				netblog_updateURIbyID($_POST['uri_id'],$_POST['uri'],$_POST['title'],0);
			else {
				$o[] = array( $_POST['uri_id'],$_POST['uri'],$_POST['title'],$node['flag'] );
				echo netblog_ajax_parse_nodeInfos($o);
				die();
			}

		// RESTORE
		case 4:
			$node = netblog_getURI($uri);
			if( (int) $node['flag'] < 3 )
				netblog_updateURIbyID($_POST['uri_id'],$_POST['uri'],$_POST['title'],0);
			else {
				$o[] = array( $_POST['uri_id'],$_POST['uri'],$_POST['title'],$node['flag'] );
				echo netblog_ajax_parse_nodeInfos($o);
				die();
			}
			
		// CHECK ONLINE STATUS
		case 10:
			// get old flag			
			$node = netblog_getURI($uri);			
			$flag = $node['flag'] == '1' ? 0 : $node['flag'];				
			$flagNew = $flag;			
			
			// check availability
			$fd = @fopen($_POST['uri'],'r');
			if( !$fd ) $flagNew = max(1,$flag);
			
			if( $flagNew != $node['flag'] ) 
				netblog_updateURIbyID( $_POST['uri_id'], $_POST['uri'], $_POST['title'], $flagNew );
			
			
			$o[] = array( $_POST['uri_id'],$_POST['uri'],$_POST['title'],$flagNew );
			echo netblog_ajax_parse_nodeInfos($o); 
			break;	

		// UPDATE TITLE
		case 11:
			$node = netblog_getURI($uri);
			$flag = $node['flag'] == '1' ? 0 : $node['flag'];
			
			// check availability
			$fd = @fopen($_POST['uri'],'r');
			$flagNew = $fd !== false ? $flag : max(1,$flag);
			
			// DIRECT READ - SAVE WEBSEARCH QUOTA
			$titleNew = null;
			if( $fd ) {
				$titleNew = url_grab_title($fd);	
				if( $titleNew != null && strlen($titleNew) > 3 ) 
					$title = $titleNew;
			}
			// URI NOT READABLE - MIGHT BE A DOCUMENT, PDF, DOC,.. - USE WEBSEARCH -- MIGHT RETURN WRONG TITLE!
			if( $titleNew == null ) {
				$titleNew = URI_get_title_bySearch($uri);
				if( $titleNew != null && strlen($titleNew) > 3 )
					$title = $titleNew;
				else if($fd) { echo 'false'; die(); }
			}

			netblog_updateURIbyID( $node['uri_id'], $node['uri'], $title, $flagNew );
			
			$o[] = array( $_POST['uri_id'],$_POST['uri'],$title,$flagNew );
			echo netblog_ajax_parse_nodeInfos($o); 			
			break;
		default: echo 'false';
	}
	
	die();
}
add_action('wp_ajax_remove_link', 'netblog_ajax_remove_link');
function netblog_ajax_remove_link()
{	
	//if( netblog_removeURI($_POST['uri_id']) )
	//	echo 'true';
	//else echo 'false';
	echo 'true';
	die();
}






add_action('wp_ajax_send_newAdjNode', 'netblog_ajax_newNode');
function netblog_ajax_newNode()
{
	global $wpdb;
	
	$nodeID = $_POST['nodeID'];
	$adjID = $_POST['adjNodeID'];	
	if( netblog_addAdjacent($nodeID,$adjID) ) {
		$adj = netblog_getInfos($adjID);
		$adj[0]['post_permalink'] = get_permalink($adjID);
		$adj[0]['post_editlink'] = get_edit_post_link($adjID);
		echo netblog_ajax_parse_nodeInfos($adj);
	} else echo 'false';
	die();
}


add_action('wp_ajax_send_newAdjNodeExtern', 'netblog_ajax_newNodeExtern');
function netblog_ajax_newNodeExtern()
{
	global $wpdb;
	$nodeID = $_POST['nodeID'];
	$uri = $_POST['uri'];
	$uriTitle = $_POST['uri_title'];
	
	if( netblog_addAdjacent($nodeID,$uri,true,$uriTitle) )
		echo 'true';
	else echo 'false';	
	die();
}

add_action('wp_ajax_send_rmAdjNode', 'netblog_ajax_rmAdjNode');
function netblog_ajax_rmAdjNode()
{
	global $wpdb;
	$nodeID = $_POST['nodeID'];
	$adjID = $_POST['adjNodeID'];
	
	$extern = !is_numeric($adjID);
	
	if( netblog_removeAdjacent($nodeID,$adjID,$extern) )
		echo 'true';
	else echo 'false';
	
	die();
}

add_action('wp_ajax_send_rmAdjNodeExtern', 'netblog_ajax_rmAdjNodeExtern');
function netblog_ajax_rmAdjNodeExtern()
{
	global $wpdb;
	$nodeID = $_POST['nodeID'];
	$uri = $_POST['uri'];
	
	if( netblog_removeAdjacent($nodeID,$uri,true) )
		echo 'true';
	else echo 'false';
	die();
}


add_action('wp_ajax_send_childNodes', 'netblog_ajax_childNodes');
function netblog_ajax_childNodes()
{
	global $wpdb;
	$nodeID = $_POST['nodeID'];	
	$num = 0;
	$out = array();
	
	// INTERN NET
	$adjs = netblog_getAdjacents($nodeID,true);
	for( $i=0; $i<sizeof($adjs); $i++ ) {
		$out[$num]['id'] = $adjs[$i]['ID'];
		$out[$num]['title'] = $adjs[$i]['post_title'];
		$out[$num]['auth'] = $adjs[$i]['user_nicename'];
		$out[$num]['date'] = $adjs[$i]['post_date'];
		$out[$num]['status'] = $adjs[$i]['post_status'];
		$out[$num]['type'] = $adjs[$i]['post_type'] == 'attachment' ? $adjs[$i]['post_mime_type'] : $adjs[$i]['post_type'];
		$out[$num]['permalink'] = get_permalink($adjs[$i]['ID']);
		$out[$num]['editlink'] = get_edit_post_link($adjs[$i]['ID']);
		$num++;
	}
	
	// EXTERN NET
	$adjs = netblog_getAdjacents($nodeID,true,true);
	for( $i=0; $i<sizeof($adjs); $i++ ) {
		$out[$num]['id'] = $i-100;
		$out[$num]['title'] = $adjs[$i]['uri_title'];
		$out[$num]['auth'] = ' ';
		$out[$num]['date'] = ' ';
		$out[$num]['status'] = ' ';
		$out[$num]['type'] = 'extern';
		$out[$num]['permalink'] = $adjs[$i]['uri'];
		$out[$num]['editlink'] = ' ';
		$num++;
	}
	
	echo netblog_ajax_parse_nodeInfos($out);
	die();
}

add_action('wp_ajax_cite_filter_preview', 'netblog_ajax_cite_filterPreview');
function netblog_ajax_cite_filterPreview()
{
	$filter = netblog_cite_parse_cstring($_POST['filter']);
	$dft = netblog_sc_cite_get_attsdft();
	foreach( $dft as $k=>$v )
		$dft[$k] = strtoupper($k);//ucfirst($k);
	extract($dft);
	echo eval("return \"$filter\" ;");
	die();
}



function netblog_ajax_parse_nodeInfos( $nodes )
{
	for( $i=0; $i<sizeof($nodes); $i++ )
		$nodes[$i] = implode( constant('NETBLOG_AJAX_DELIM_KEYSUB'), $nodes[$i] );
	return implode( constant('NETBLOG_AJAX_DELIM_KEYMAIN'), $nodes );
}

function netblog_post_save( $post_id )
{
	// verify this came from the our screen and with proper authorization,
	// because save_post can be triggered at other times
	if ( !wp_verify_nonce( $_POST['netblog_noncename'], plugin_basename(__FILE__) )) {
	  return $post_id;
	}
	
	// verify if this is an auto save routine. If it is our form has not been submitted, so we dont want
	// to do anything
	if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) 
	  return $post_id;
	 
	// Check permissions
	if ( 'page' == $_POST['post_type'] ) {
	  if ( !current_user_can( 'edit_page', $post_id ) )
	    return $post_id;
	} else {
	  if ( !current_user_can( 'edit_post', $post_id ) )
	    return $post_id;
	}
	
	// saving work
}
?>