
function netblog_autocomplete()		// as a class
{	
	// 
	// MEMBER DATA
	//
	this.wndObj = null;
	this.ribbonObj = null;
	this.inputObj = null;	
	
	this.inputMin = 3;
	this.inputLast = '';
	this.inputDefaultValue = 'Type here';
	this.inputDefaultStyle = 'text-input-hint';
	this.inputStyle = '';
	this.isInputDefault = false;
	this.updateInputOnSlct = true;
	
	this.objName = '';
	this.objIDNamespace = 'autocomplete';	
	this.obj = null;
	
	this.list = new Array();
	this.listSizeMax = 10;
	this.lastRowNum = -1;
	this.listSlctRow = -1;
	this.listRowClassActive = 'row-active';
	this.listRowClass = 'row';
	
	this.listFooterValue = '';
	
	this.actionSubmitObj = null;
	this.ontypeIsFreeze = false;
	this.ontypeCalls = 0;
	this.isRequestServ = false;
	
	this.CBAppendListHndl = null;
	this.CBAppendListHndlObj = null;
	this.CBChosenElem = null;
	this.CBChosenElemObj = null;
	this.CBFormaterRow = null
	this.CBFormaterRowObj = null
	this.CBFormaterInput = null
	this.CBFormaterInputObj = null;
	
	
	this.groups = [];
	
	
	// 
	// PUBLIC METHODS
	//
	
	this.init = function( ribbonID, InputTxtID, WndID, objName, obj ) 
	{
		this.ribbonObj = document.getElementById(ribbonID);
		this.inputObj = document.getElementById(InputTxtID);
		this.wndObj = document.getElementById(WndID);
		this.objName = objName;
		this.obj = obj;
		
		// LISTENER - FIREFOX,W3C
		if( window.addEventListener ) {
			this.inputObj.addEventListener('focus', function() { obj.leaveInputDefault(); if(obj.listSize() > 0) obj.show(150) }, false );
			this.inputObj.addEventListener('blur', function() { obj.enterInputDefault(); obj.hide(300) }, false );
			this.inputObj.addEventListener('keyup', function() { obj.ontypeCalls++; obj.ontype(250) }, false );
			this.inputObj.addEventListener('keydown', function() { obj.UIHandler() }, false );
		} else if( window.attachEvent ) {
		// LISTNER - IE5+
			this.inputObj.attachEvent('onfocus', function() { obj.leaveInputDefault(); if(obj.listSize() > 0) obj.show(150) } );
			this.inputObj.attachEvent('onblur', function() { obj.enterInputDefault(); obj.hide(300) } );
			this.inputObj.attachEvent('onkeyup', function() { obj.ontypeCalls++; obj.ontype(250) } );
			this.inputObj.attachEvent('onkeydown', function() { obj.UIHandler() } );
		}
		
		// GROUPS
		if( this.hasGroups() )
			this.initGroups();
		
		this.inputStyle = this.inputObj.className;
		this.enterInputDefault();

		this.hide(0);
		this.clear();		
	}
	this.doaction_submitbutton = function( buttonID ) { this.actionSubmitObj = document.getElementById(buttonID); }
	this.enterInputDefault = function() 
	{
		if( this.isInputDefault || this.inputObj.value.length > 0 ) return false;
		this.inputObj.className = this.inputDefaultStyle;
		this.setInput( this.inputDefaultValue );
		this.isInputDefault = true;
		return true;
	}
	this.leaveInputDefault = function()
	{
		if( !this.isInputDefault ) return false;
		this.inputObj.className = this.inputStyle;
		this.setInput('');
		this.isInputDefault = false;
		return true;
	}
	this.ontype = function( delay )
	{
		if( delay > 0 ) {
			if( typeof(setTimeoutRefresh) == 'function' )
				setTimeoutRefresh( this.objName + '-ontype' ,this.objName + '.ontype(0)', delay );
			else setTimeout( this.objName + '.ontype(0)', delay );
			return ;
		}		
		
		if( this.ontypeIsFreeze )
			return false;
		
		if( this.inputObj.value.length < this.inputMin ) {
			this.hide(0);
			this.clear();
			return false;
		}
		if( this.inputObj.value == this.inputLast ) {
			return false;
		}
		
		var id = this.getCurRowID();
		var val = this.getCurRowValue();

		//this.clear();
		
		this.inputLast = this.inputObj.value;
		
		if( typeof(this.CBAppendListHndl) != undefined && !this.isRequestServ ) {
			//this.isRequestServ = true;
			this.CBAppendListHndl.call( this.CBAppendListHndlObj, this.inputObj.value );
				/* this.CBAppendListHndlObj needs to call this.lastRequestSuccess(true)
				*/
			//this.isRequestServ = false;
		}
		return true;
	}
	this.lastRequestSuccess = function(bool)
	{
		this.isRequestServ = !bool;
	}
	
	this.choose = function( rowNum )
	{
		if( !this.isInList(rowNum) ) return false;
			
		this.inputObj.value = this.getValuebyRow( rowNum );
		this.hide(200);
		this.lastRowNum = rowNum;		
		this.inputLast = this.inputObj.value;
		this.selectRowAbs( rowNum );
		
		if( typeof(this.CBChosenElem) != undefined )
			this.CBChosenElem.call( this.CBChosenElemObj, this.getCurRowID(), this.getCurRowValue() );
		else if( this.actionSubmitObj != null )
			this.actionSubmitObj.click();
	}
	
	this.selectRowAbs = function( rowNum )
	{
		this.selectRow( rowNum - this.listSlctRow );
	}
	
	this.getCurRowID = function() { return this.getIDbyRow( this.lastRowNum ); }
	this.getCurRowValue = function() { return this.getValuebyRow( this.lastRowNum ); }
	this.getInputStr = function() { return this.inputObj.value; }
	
	this.append = function( id, e ) { this.appendG(id,e,''); }
	this.appendG = function( id, e, group ) { 
		if( this.findID(id) != -1 )
			return false;

		var row = '<a onclick="'+this.objName+'.choose('+this.list.length+')" '
					+'id="'+this.mkWndRowID(this.list.length)+'" class="'+this.listRowClass+'">'+this.formatRow(e)+'</a>'; 

		if( this.hasGroups() && this.isGroup(group) && document.getElementById(this.mkGroupID(group)) != null )
			document.getElementById(this.mkGroupID(group)).innerHTML += row;
		else this.wndObj.innerHTML += row;

		this.addEntry( id, e );
	}
	
	this.findID = function( id ) {
		var i;
		for( i=0; i<this.list.length; i++ ) {
			if( this.getIDbyRow(i) == id )
				return i;
		}
				
		return -1;
	}
	
	/* OPTIONAL PARAMETER */
	this.setMinInputLength = function(i) { if(i>0) this.inputMin = i;}
	this.setInputDefaultValue = function(str) { if(str.length>0) this.inputDefaultValue = str; }
	this.setFooter = function(str) { if(str.length>0) this.listFooterValue = str; }
	this.printFooter = function() 
	{
		if( this.listFooterValue.length > 0 )  {
		//	this.wndObj.innerHTML += '<div class="footer"><div class="rtft">' + this.listFooterValue + '</div><div class="clear"></div></div>';
			this.wndObj.innerHTML += '<div class="footerRight">' + this.listFooterValue + '</div><div class="clear"></div>';
		}
	}
	
	
	
	/* GROUPS */
	this.createGroup = function( name, screenName ) {
		if( !this.isGroup(name) )
			this.groups.push( [name,screenName] );
	}
	this.isGroup = function( name )
	{
		return this.getGroupIndex(name) >= 0;
	}
	this.getGroupIndex = function( name )
	{
		var i;
		for( i=0; i<this.groups.length; i++ )
			if( name == this.groups[i][0] )
				return i;
		return -1;
	}
	this.rmGroup = function(name) {
		return this.groups.splice( this.getGroupIndex(name), 1 ) != null;
	}
	this.hasGroups = function() { return this.groups.length > 0; }
	this.mkGroupID = function( name )
	{
		return this.objIDNamespace + '-group-' + name;
	}
	this.initGroups = function()
	{
		var g = '', i;
		for( i=0; i<this.groups.length; i++ )
			g += '<div class="label">'+ this.groups[i][1] +'</div><div id="'+ this.mkGroupID(this.groups[i][0]) +'" class="group"></div>';
		this.wndObj.innerHTML = g;
	}
	
	
	/* REGISTER CALLBACKS */
	this.RegisterCBAppend = function( obj, funcObj, inputStr ) 
		{ this.CBAppendListHndl = funcObj; this.CBAppendListHndlObj = obj; }
	this.RegisterCBChosen = function( obj, funcObj, inputID, inputStr ) 
		{ this.CBChosenElem = funcObj; this.CBChosenElemObj = obj; }
	this.RegisterCBFormater = function( obj, funcObj, e ) 
		{ this.CBFormaterRow = funcObj; this.CBFormaterRowObj = obj; }	
	this.RegisterCBFormaterInput = function( obj, funcObj, e ) 
		{ this.CBFormaterInput = funcObj; this.CBFormaterInputObj = obj; }		
	
	
	
	
	
	
	
	
	
	
	
	
	//
	// PRIVATE METHODS
	//
	this.show = function( timeOffset ) 
	{
		if( timeOffset == 0 )
			this.wndObj.style.display = 'block';
		else setTimeout( this.objName+'.show(0)', timeOffset );
	}
	this.hide = function( timeOffset ) 
	{ 
		if( timeOffset == 0 )
			this.wndObj.style.display = 'none';
		else setTimeout( this.objName+'.hide(0)', timeOffset ); 
	}
	this.isVisible = function() { return this.wndObj.style.display == 'block' ; }
	this.reveal = function() 
	{
		if( this.isVisible() )
			this.hide(0);
		else if( this.list.length > 0 ) this.show(0);
	}
	
	this.clear = function() { this.wndObj.innerHTML = ''; this.initGroups(); this.list = []; this.listSlctRow = -1; }
	
	this.ontypeFreeze = function() { this.ontypeIsFreeze = true; }
	this.ontypeUnFreeze = function() { this.ontypeIsFreeze = false; }
	this.setInput = function( str ) 
	{			
		this.ontypeFreeze();
		this.inputObj.value = str;
		
		if( str == this.inputDefaultValue ) {
			this.clear();
		} else {			
			this.inputLast = str;	
			if( str.length < this.inputMin )
				this.clear();		
		}
		
		this.ontypeUnFreeze();

		
	}
	
	this.formatRow = function(e)
	{
		if( this.CBFormaterRow != null )
			return this.CBFormaterRow.call( this.CBFormaterRowObj, e );
		else return e;
	}
	
	this.mkWndRowID = function( rowNum ) { return this.objIDNamespace+'_wnd_'+rowNum; }
	this.addEntry = function( id, str )
	{
		var x = [id,str];
		this.list.push( x );
		this.show(0);
	}
	
	
	this.getIDbyRow = function( rowID ) { return (rowID>=0 && rowID<this.list.length) ? this.list[rowID][0] : -1; }
	this.getValuebyRow = function( rowID ) { return (rowID>=0 && rowID<this.list.length) ? this.list[rowID][1] : ''; }	
	
	this.hasSpace = function() { return this.list.length < this.listSizeMax; }	
	this.listSize = function() { return this.list.length; }
	this.isInList = function( id ) { return id >= 0 && id < this.list.length; }	
	this.setWithinList = function( id ) 
	{
		if( id < 0 ) return 0;
		if( id >= this.list.length ) return this.list.length-1;
		return id;
	}
	
	this.selectRow = function( step )
	{
		old = this.listSlctRow;
		this.listSlctRow = (this.listSlctRow + step + this.list.length) % this.list.length;
		
		this.deselectRow(old);
		
		document.getElementById( this.mkWndRowID(this.listSlctRow) ).className = this.listRowClassActive;
		
		var newInput;
		if( this.CBFormaterInput != null )
			newInput = this.CBFormaterInput.call( this.CBFormaterInputObj, this.getValuebyRow(this.listSlctRow) );
		else newInput = this.getValuebyRow(this.listSlctRow);
		
		this.setInput( newInput );
	}
	this.deselectRow = function( id )
	{
		if( this.isInList(id) ) document.getElementById( this.mkWndRowID(id) ).className = this.listRowClass;
	}
	this.resetSelectRow = function() { this.deselectRow(this.listSlctRow); this.listSlctRow = -1; }
	this.isSelectedRow = function(id) { return id == this.listSlctRow; }
	
	this.UIHandler = function()
	{
		if( this.inputObj.value == this.inputLast ) {
			if( event.keyCode == 38 )		/* up-arrow */
				this.isVisible() ? this.selectRow(-1) : this.show(0);
			if( event.keyCode == 40 )		/* down-arrow */
				this.isVisible() ? this.selectRow(1) : this.show(0);
			if( event.keyCode == 27 ) 		/* ESC */
				this.hide(0);
			if( event.keyCode == 13 )		/* Enter */
				this.choose( this.listSlctRow );
			return false;
		}		
	}
	
}