
function netblog_lister()
{
	//
	// DATA MEMBER
	//
	this.listObj = null;
	this.listObjDiv = null						/* upon call of setFormatMode with mode = list; make restore possible */
	
	this.list = new Array();
	this.isSortImmediate = false;
	this.appendMode = 2;						/* 0 := begin, 1 := middle (-> sort), 2:= end */
	this.submenuMode = 2;						/* 0 := none; 1 := left, 2 := right */
	this.formatMode = 0;						/* 0 := table/rows, 1:=unnumbered list, 2:= numbered list, 3:=XList */
	
	this.scopeID = '';
	this.objName = '';
	
	this.OnRemoveWaitFeedback = false;			/*  */
	this.OnRemoveMemory = -1;
	
	this.CBFormatElem = null;
	this.CBFormatElemObj = null;
	this.CBOnRemoveElem = null;
	this.CBOnRemoveElemObj = null;
	
	//
	// PUBLIC MEMBER FUNCTIONS
	//
	this.init = function( listID, objName )
	{
		this.listObj = document.getElementById(listID);
		this.scopeID = listID+'_';
		this.objName = objName;
		this.listObj.innerHTML = '';
	}
	this.add = function( id, str ) 
	{
		if( this.findRowID(id) == '' ) {
			this.addEntry(id,str);
			return true;
		} else return false;
	}
	this.addTop = function( id, e )
	{
		var mode = this.appendMode;
		this.appendMode = 0;
		this.add(id,e);
		this.appendMode = mode;
	}
	this.addBottom = function( id, e )
	{
		var mode = this.appendMode;
		this.appendMode = 2;
		this.add(id,e);
		this.appendMode = mode;
	}
	this.remove = function( id )
		{ return this.removeEntry(id); }
	this.removeOK = function(bool)
	{
		if( this.OnRemoveWaitFeedback && bool && this.findRowID(this.OnRemoveMemory) != '' ) {
			this.OnRemoveWaitFeedback = false;
			this.removeEntry( this.OnRemoveMemory );
			this.OnRemoveWaitFeedback = true;
		}
		if( this.OnRemoveWaitFeedback && !bool )
			this.OnRemoveMemory = -1;
	}
	this.sort = function( e, isDesc )
	{
		if( e < 0 || e >= 2 ) return false;
		
		for( i=0; i<this.list.length; i++ ) {
			var t = this.list[i];
			var p;
			for( p=i-1; p>=0; p-- ){
				if( this.compare(t,this.list[p],e) < 0 )
					this.list[p+1] = this.list[p];
				else break;
			}
			this.list[p+1] = t;
		}		

		if( isDesc ) this.list.reverse();
		
		this.update();
	}
	this.clear = function()
	{
		while( this.list.length > 0 )					/* ensure remove feedback */
			this.removeEntry( this.getIDByArray(this.list[0]) );
		//this.hide(); this.list = []; this.listObj.innerHTML = ''; 
	}
	this.findRowID = function( id )
		{ return this.getIDByArray( this.findElem(0,id) ); }
	this.findRowStr = function( str )
		{ return this.getStrByArray( this.findElem(1,str) ); }
	
	this.registerCBFormatElem = function( obj, objFunc, id, str, callRemoveAsStr )
		{ this.CBFormatElem = objFunc; this.CBFormatElemObj = obj; }
	this.registerCBOnRemoveElem = function( obj, objFunc, id, elem )
		{ this.CBOnRemoveElem = objFunc; this.CBOnRemoveElemObj = obj; }
	
	this.setSortImmediate = function( boolean )
		{ this.isSortImmediate = boolean; }
		
	this.setAppendMode = function( mode )
	{
		if( mode == 'begin' || mode == 0 )
			this.appendMode = mode;
		if( mode == 'middle' || mode == 1 )
			this.appendMode = mode;
		if( mode == 'end' || mode == 2 )
			this.appendMode = mode;
	}
	this.setSubmenuMode = function( mode )
	{
		if( mode == 'none' || mode == 0 )
			this.submenuMode = 0;		
		if( mode == 'left' || mode == 1 )
			this.submenuMode = 1;
		if( mode == 'right' || mode == 2 )
			this.submenuMode = 2;
		this.update();
	}
	this.setFormatMode = function( mode )
	{
		if( mode == 'table' || mode == 0 ) {
			this.formatMode = 0;
			if( this.listObjDiv != null )
				this.listObj = this.listObjDiv;
		} 
		if( mode == 'xlist' || mode == 3 ) {
			this.formatMode = 3;
			if( this.listObjDiv != null ) 
				this.listObj = this.listObjDiv;
		}
		if( mode == 'ulist' || mode == 1 ) {
			this.formatMode = 1;
			var listID = this.scopeID+'ulist';
			this.show();
			this.listObj.innerHTML = '<ul id="'+listID+'"></ul>';
			this.listObjDiv = this.listObj;
			this.listObj = document.getElementById(listID);
		}
		this.update();
	}
	
	this.setOnRemoveWaitFeedback = function(bool) 
		{ this.OnRemoveWaitFeedback = bool; }
	this.getOnRemoveWaitFeedback = function() 
		{ return this.OnRemoveWaitFeedback;}	
	
	
	
	
	//
	// PRIVATE MEMBER FUNCTIONS
	//
	this.addEntry = function( id, str )
	{
		var x = [id,str];
		var e = this.findElemGetIndex(0,id);
		if( e == -1 ) {
			this.list.push(x);

			if( this.appendMode == 0 )
				this.listObj.innerHTML = this.formatRow(id,str) + this.listObj.innerHTML;
			else
				this.listObj.innerHTML += this.formatRow( id, str );
				
			if( this.isSortImmediate || this.appendMode == 1 )
				this.sort(1,true);
			this.show();
			
			if( typeof(show) == 'function' )
				show( this.mkRowID(id), 0, 1000 );
			
		} else {
			var obj = document.getElementById( this.mkRowID(id) );
			if( obj != undefined || obj != null )
				obj.innerHTML = this.formatStr(id,str);
		}
	}
	this.removeEntry = function( id )
	{
		if( this.OnRemoveWaitFeedback && this.CBOnRemoveElem != null ) {
			this.OnRemoveMemory = id;
			this.CBOnRemoveElem.call( this.CBOnRemoveElemObj, id, this.getStrByArray(this.findElem(0,id)) );
			return;
		}
			
		var e = this.findElemGetIndex(0,id);		
		if( e >= 0 ) {
			for( i=e; i<this.list.length-1; i++ )
				this.list[i] = this.list[i+1];
			this.list.pop();
			this.update();
			if( this.list.length == 0 )
				this.hide();
		}
		return true;
	}
	this.compare = function( subarr1, subarr2 , e )
	{
		var elem1 = subarr1[e];
		var elem2 = subarr2[e];
		if( this.isString(elem1) ) elem1 = elem1.toLowerCase();
		if( this.isString(elem2) ) elem2 = elem2.toLowerCase();
		if( elem1 < elem2 ) return -1;
		if( elem1 > elem2 ) return 1;
		return 0;
	}
	this.isString = function( obj )
	{
		return ( typeof(obj) == "string" || obj instanceof String );
	}
	this.update = function() 
	{
		var t = '';		
		for( i=0; i<this.list.length; i++ )
			t += this.formatRow( this.getIDByArray(this.list[i]), this.getStrByArray(this.list[i]) );
		this.listObj.innerHTML = t;
		if( this.list.length > 0 )
			this.show();
		else this.hide();
	}
	
	
	this.formatRow = function( id, str )
	{	
		var c;
		var f = this.formatStr(id,str);
		if( this.formatMode == 1 ) {			
			c = '<li id="'+this.mkRowID(id)+'">'+f+'</li>';
		} else if( this.formatMode == 3 ) {
			c = '<div class="xlist" id="'+this.mkRowID(id)+'" style=""><a class="del" onclick="'+this.objName+'.remove(\''+id+'\')"></a><div class="content">'+f+'</div></div>';
		} else {
			f = '<div class="content">'+f+'</div>';			
			var t = '<div class="submenu"><a class="del" onclick="'+this.objName+'.remove('+id+')" ></a></div>' + f;
			if( this.submenuMode == 1 )
				f = '<div class="menuLeft">' + t + '</div>';
			else if( this.submenuMode == 2 )
				f = '<div class="menuRight">' + t + '</div>';
			c = '<div class="row" id="'+this.mkRowID(id)+'">'+f+'</div>';
		}
		
		return c;
	}
	
	this.findElem = function( arrayID, elem ) 
	{
		var i = this.findElemGetIndex(arrayID,elem);
		if( i >= 0 )
			return this.list[i];
		else return new Array();
	}
	this.findElemGetIndex = function( subarrayID, elem )
	{
		var i;
		if( subarrayID >= 0 && subarrayID < 2 )
		for( i=0; i<this.list.length; i++ )
			if( this.list[i][subarrayID] == elem )
				return i
		return -1;		
	}
	this.getStrByArray = function( arrayRow ) { return arrayRow.length == 2 ? arrayRow[1] : '';}
	this.getIDByArray = function( arrayRow ) { return arrayRow.length == 2 ? arrayRow[0] : '';}

	this.show = function() { this.listObj.style.display = 'block'; }
	this.hide = function() { this.listObj.style.display = 'none'; }

	this.mkRowID = function( id ) { return this.scopeID+'row'+id; }
	
	this.formatStr = function( id, str ) 
	{ 
		if( this.CBFormatElem != null )
			return this.CBFormatElem.call( this.CBFormatElemObj, id, str, this.objName+'.remove('+id+')' );		
		return str;
	}
}

